# voidpin

Voidpin allows sending copy/paste commands across the wire. It is specifically intended for use in ssh tunnels for long running sessions, where you want to share a clipboard. The primary use case is when a remote machine is used for development, but clipboard continues to be an ergonomic hurdle.

Voidpin sends clipboard content to a local service, that then puts content in a local clipboard. It can also go the other way, but the primary intent is remote -> local.

## Demo

![demo](assets/demo.gif)

## Usage

```bash
# Local
voidpin copy  

# Remote
ip a # 10.0.9.1
voidpin listen & # make voidpin listener run in background

# login to remote
ssh remote@remote
export VOIDPIN_REMOTE=http://10.0.9.1:7900
echo "some content" | voidpin remote copy

# In a browser for example
# Ctrl+v or Command+v
```
